/*
 * nls/cpmisc.c
 * ASCII to Unicode and Back
 * 
 */
#include <windows.h>
#include <kernel32/lctable.h>
#include <kernel32/cptable.h>

WCHAR __ASCII_00[32]=
{
   0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
   0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
   0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17,
   0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F
};

WCHAR __ASCII_20[32]=
{
   ' ' , '!' , '\"', '#' , '$' , '%' , '&' , '\'',
   '(' , ')' , '*' , '+' , ',' , '-' , '.' , '/' ,
   '0' , '1' , '2' , '3' , '4' , '5' , '6' , '7' ,
   '8' , '9' , ':' , ';' , '<' , '=' , '>' , '?'
};

WCHAR __ASCII_40[32]=
{
   '@' , 'A' , 'B' , 'C' , 'D' , 'E' , 'F' , 'G' ,
   'H' , 'I' , 'J' , 'K' , 'L' , 'M' , 'N' , 'O' ,
   'P' , 'Q' , 'R' , 'S' , 'T' , 'U' , 'V' , 'W' ,
   'X' , 'Y' , 'Z' , '[' , '\\', ']' , '^' , '_'
};

WCHAR __ASCII_60[32]=
{
   '`' , 'a' , 'b' , 'c' , 'd' , 'e' , 'f' , 'g' ,
   'h' , 'i' , 'j' , 'k' , 'l' , 'm' , 'n' , 'o' ,
   'p' , 'q' , 'r' , 's' , 't' , 'u' , 'v' , 'w' ,
   'x' , 'y' , 'z' , '{' , '|' , '}' , '~' , 0x7F
};

CHAR __ASCII_0000[32]=
{
   0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
   0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
   0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17,
   0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F
};

CHAR __ASCII_0020[32]=
{   
   ' ' , '!' , '\"', '#' , '$' , '%' , '&' , '\'',
   '(' , ')' , '*' , '+' , ',' , '-' , '.' , '/' ,
   '0' , '1' , '2' , '3' , '4' , '5' , '6' , '7' ,
   '8' , '9' , ':' , ';' , '<' , '=' , '>' , '?' 
};

CHAR __ASCII_0040[32]=
{
   '@' , 'A' , 'B' , 'C' , 'D' , 'E' , 'F' , 'G' ,
   'H' , 'I' , 'J' , 'K' , 'L' , 'M' , 'N' , 'O' ,
   'P' , 'Q' , 'R' , 'S' , 'T' , 'U' , 'V' , 'W' ,
   'X' , 'Y' , 'Z' , '[' , '\\', ']' , '^' , '_' 
};

CHAR __ASCII_0060[32]=
{
   '`' , 'a' , 'b' , 'c' , 'd' , 'e' , 'f' , 'g' ,
   'h' , 'i' , 'j' , 'k' , 'l' , 'm' , 'n' , 'o' ,
   'p' , 'q' , 'r' , 's' , 't' , 'u' , 'v' , 'w' ,
   'x' , 'y' , 'z' , '{' , '|' , '}' , '~' , 0x7F
};

WCHAR __NULL_00[32]=
{
   0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
   0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
   0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
   0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
};

CHAR __NULL_0000[32]=
{
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

CHAR *__NULL_00XX[32]=
{
   __NULL_0000, __NULL_0000, __NULL_0000, __NULL_0000,
   __NULL_0000, __NULL_0000, __NULL_0000, __NULL_0000,
   __NULL_0000, __NULL_0000, __NULL_0000, __NULL_0000,
   __NULL_0000, __NULL_0000, __NULL_0000, __NULL_0000,
   __NULL_0000, __NULL_0000, __NULL_0000, __NULL_0000,
   __NULL_0000, __NULL_0000, __NULL_0000, __NULL_0000,
   __NULL_0000, __NULL_0000, __NULL_0000, __NULL_0000,
   __NULL_0000, __NULL_0000, __NULL_0000, __NULL_0000
};
 